
module coords
  implicit none

  private
  public :: point
  
  type point
     real :: x,y,z
   contains
     procedure,private :: pointplus, pointminus, pointseparation
     procedure,private,pass(this) :: absvec
     generic,public :: operator(+) => pointplus
     generic,public :: operator(-) => pointminus
     generic,public :: operator(.distance.) => pointseparation
     generic,public :: assignment(=) => absvec
  end type point

contains

  type(point) function pointplus(this,b)   ! for +
    class(point),intent(in):: this,b
    pointplus%x = this%x + b%x
    pointplus%y = this%y + b%y
    pointplus%z = this%z + b%z
  end function pointplus
  
  type(point) function pointminus(this,b)  !  for -
    class(point),intent(in):: this,b
    pointminus%x = this%x - b%x
    pointminus%y = this%y - b%y
    pointminus%z = this%z - b%z
  end function pointminus

  real function pointseparation(this,b) ! for .distance.
    class(point),intent(in):: this,b
    pointseparation = sqrt(  &
         (this%x-b%x)**2+(this%y-b%y)**2+(this%z-b%z)**2)
  end function pointseparation

  subroutine absvec(a,this)  ! for = (distance
    real,intent(out):: a     !  from origin)
    class(point),intent(in):: this
    a = sqrt(this%x**2+this%y**2+this%z**2)
  end subroutine absvec
  
end module coords
